// Karma configuration
// http://karma-runner.github.io/0.10/config/configuration-file.html
module.exports = function(config) {
  config.set({
    // base path, that will be used to resolve files and exclude
    basePath: '../../',

    // testing framework to use (jasmine/mocha/qunit/...)
    frameworks: [
      'jasmine',
      'jasmine-matchers'
    ],

    // patterns to load in the browser
    //    - handled by gulp.js task.

    // files / patterns to exclude
    //    - handled by gulp.js task.

    preprocessors: {
      './src/js/**/*.js': 'coverage'
    },

    reporters: [
      'nested',
      'coverage'
    ],

    coverageReporter: {
      type : 'html',
      dir : './test/coverage'
    },

    // web server port
    port: 8081,

    // level of logging
    // possible values: LOG_DISABLE || LOG_ERROR || LOG_WARN || LOG_INFO || LOG_DEBUG
    logLevel: config.LOG_INFO,

    // enable / disable watching file and executing tests whenever any file changes
    autoWatch: false,

    // Start these browsers, currently available:
    // - Chrome
    // - ChromeCanary
    // - Firefox
    // - Opera
    // - Safari (only Mac)
    // - PhantomJS
    // - IE (only Windows)
    browsers: ['PhantomJS'],

    // Continuous Integration mode
    // if true, it capture browsers, run tests and exit
    singleRun: false
  });
};
